@startuml

class Private {
  +get(caller)
  +set(newValue, caller)
  +log()
}

class Particle {
  +wave: array
  +value: Proxy
  +_private: Private
  +owner: Private
  +log()
}

class Wave {
}

class Loader {
  +{static} discover()
  +{static} canLoad(urlObject)
  +{static} factory(urlObject)
  +name: string
  +client()
  +getIOR()
  +load(namespace)
  +namespace2path(namespace)
  +path2namespace(path)
  +checkLoader(object)
  +{static} get staticStore()
  +get staticStore()
  +{static} get instanceStore()
}

class TypeDescriptor {
  +class: undefined
  +dependencies: undefined
  +extends: undefined
  +interfaces: array
  +implements: array
  +uses: array
  +_usedBy: array
  +isInstance: undefined
  +name: undefined
  +namespace: undefined
  +package: undefined
  +weBeans: undefined
  +actionIndex: undefined
  +usedBy: array
  +init(object)
  +toJSON()
  +get version()
  +get ucpComponentDescriptor()
  +set ucpComponentDescriptor(newValue)
}

class Namespace {
  +{static} discover()
  +{static} get RootNamespace()
  +{static} currentScriptInfo()
  +{static} declare(...args)
  +init(name, namespace)
  +lookup(fullQualifiedNameString)
  +get name()
  +set name(newValue)
  +get parent()
  +get package()
  +{static} isVersionName(name)
  +isVersionName()
  +namespace2path()
  +{static} path2namespace(path)
}

class Thing {
  +{static} start()
  +{static} discover()
  +init()
  +load(object)
  +lookup(aClass)
  +discover()
  +call(ior, parameter)
  +getDescriptor(merge, force)
  +get uses()
  +set uses(newValue)
  +{static} get uses()
  +{static} set uses(newValue)
}

class Once extends Thing {
  +{static} get dependenciesGroups()
  +{static} get dependencies()
  +get id()
  +constructor()
  +notImplementedYet()
  +discover()
  +{static} start()
  +{static} loadENV(urlObject)
  +getServer()
  +init()
  +addStatistic(path)
  +getStatistic()
  +{static} get EVENT()
  +get type()
  +set type(newValue)
  +start(ior, config)
  +newThing(event, thing)
  +call(ior, parameter)
  +checkInstallationMode()
  +findNamespaceAndVersion(repositoryRootIndex)
  +startServer(host, dynamicPort)
  +serverLifecycle()
  +initClientsideOnce()
  +initServersideOnce()
  +startReverseProxy()
  +getMochaTestToken(request, response)
  +startCORSAnywhereproxy()
  +handleWebsocketConnection(ws, req)
  +createSessionManagerFromRequest(request, response)
  +handleUdeFind(request, response)
  +handleIORRestRequest(request, response)
  +forwardHTTPRequest(request, response)
  +handleHTTPRequest(request, response)
  +renderHTML(path, contentType, response)
  +{static} getPlatformIndependantPathString(pathString)
  +{static} getPlatformSpecificPathString(pathString)
  +register(anInterface, anInstance)
}

Once -up-|> Thing
Thing -up-|> Namespace
Namespace -up-|> TypeDescriptor
TypeDescriptor -up-|> Loader
Loader -up-|> Wave
Wave -up-|> Particle
Particle -up-|> Private

@enduml
